Capitolo 3. I rilasci di Debian

# Capitolo 3. I rilasci di Debian

Da Debian 0.01 a 0.90 (agosto-dicembre 1993)

Debian 0.91 (gennaio 1994): questa versione aveva un semplice sistema di gestione dei pacchetti che ne permetteva installazione e disinstallazione. In questa fase il progetto era cresciuto fino a coinvolgere diverse decine di persone.

Debian 0.93R5 (marzo 1995): a questo punto la responsabilità di ogni pacchetto era stata assegnata chiaramente ad uno sviluppatore e veniva usato il gestore dei pacchetti (dpkg) per installare i pacchetti dopo l'installazione del sistema di base.

Debian 0.93R6 (novembre 1995): appare dselect. Questo è stato l'ultimo rilascio di Debian ad usare il formato binario a.out; gli sviluppatori erano circa 60. Insieme al rilascio 0.93R6 è stato realizzato da Bdale Garbee il primo server master.debian.org, ospitato da HP. La realizzazione di un server ufficiale, sul quale gli sviluppatori Debian avrebbero costruito ogni rilascio, ha portato direttamente alla formazione della rete dei mirror Debian e indirettamente alla realizzazione di molte delle «politiche» e delle procedure usate oggi per coordinare il progetto.

Debian 1.0 non è mai stata rilasciata: accidentalmente il rivenditore di CD InfoMagic distribuì una versione di sviluppo di Debian a cui attribuì il nome Debian 1.0. Il giorno 11 dicembre del 1995 Debian e l'azienda InfoMagic annunciarono che questa versione era malformata. Bruce Perens poi spiegò che i dati messi sul supporto «InfoMagic Linux Developer's Resource 5-CD Set November 1995» con il nome «Debian 1.0» non corrispondono al rilascio di Debian 1.0 ma ad una preliminare versione di sviluppo, solo parzialmente in formato ELF, che probabilmente non si avvia o funziona correttamente e che non rispecchia la qualità di un rilascio di sistema Debian. Per evitare il rischio di creare confusione tra una versione prematura su CD ed un effettivo rilascio di una versione di Debian, il Progetto Debian rinominò il rilascio successivo «Debian 1.1». La prematura Debian 1.0 su CD è così considerata deprecata e non dovrebbe essere usata.

Alla fine del 1995, master.debian.org ha cambiato host: da HP a i-Connect.Net. Michael Neuffer e Shimon Shapiro, i fondatori di i-Connect.Net, hanno ospitato il master sul proprio hardware per poco più di un anno. Durante questo periodo di tempo, hanno fornito molti servizi a Debian, inclusa la gestione dell'equivalente di allora del processo di Nuovo manutentore, e aiutando in modo significativo la crescita della giovane rete dei mirror Debian.

Debian 1.1 Buzz (17 giugno 1996): questo è stato il primo rilascio con un nome in codice. Il nome era preso, come tutti gli altri fino ad ora, da un personaggio dei film Toy Story... in questo caso Buzz Lightyear. A quel punto Bruce Perens aveva sostituito Ian Murdock alla guida del Progetto Debian e Bruce stava lavorando alla Pixar, la compagnia che aveva prodotto i film. Questo rilascio utilizzava esclusivamente il formato ELF, impiegava il kernel Linux 2.0 e conteneva 474 pacchetti.

Debian 1.2 Rex (12 dicembre 1996): ha preso il nome dal dinosauro di plastica Rex dei film Toy Story. Questo rilascio era costituito da 848 pacchetti mantenuti da 120 sviluppatori.

Debian 1.3 Bo (5 giugno 1997): ha preso il nome da Bo Peep, la pastorella. Questo rilascio era costituito da 974 pacchetti mantenuti da 200 sviluppatori.

Debian 2.0 Hamm (24 luglio 1998): ha preso il nome dal salvadanaio a forma di porcellino dei film. Questo è stato il primo rilascio multi-piattaforma di Debian ed ha aggiunto il supporto all'architettura serie 68000 di Motorola. Con Ian Jackson come capo progetto, questo rilascio ha segnato la transizione alla libc6. Era costituito da più di 1500 pacchetti mantenuti da oltre 400 sviluppatori.

Debian 2.1 Slink (9 marzo 1999): ha preso il nome dal cane-molla del film. Erano state aggiunte altre due architetture, Alpha e SPARC. Con Wichert Akkerman come capo progetto, questo rilascio era costituito da circa 2250 pacchetti e richiedeva 2 CD nell'insieme ufficiale. L'innovazione tecnica principale era l'introduzione di apt, una nuova interfaccia per la gestione dei pacchetti. Nato per risolvere i problemi derivanti dalla continua crescita di Debian, apt costituì un nuovo paradigma nell'acquisizione ed installazione di pacchetti nei sistemi operativi Open Source, ed è stato largamente imitato.

Debian 2.2 Potato (15 agosto 2000): ha preso il nome da «Mr Potato» dei film Toy Story. Questo rilascio ha aggiunto il supporto alle architetture PowerPC e ARM. Con Wichert ancora come capo progetto, questo rilascio era costituito da più di 3900 pacchetti binari, derivanti da più di 2600 pacchetti di codice sorgente, mantenuti da più di 450 sviluppatori Debian.

Debian 3.0 Woody (19 luglio 2002): ha preso il nome dal protagonista dei film Toy Story: «Woody», il cowboy. In questo rilascio sono state aggiunte ancora altre architetture: IA-64, HP PA-RISC, MIPS (big endian), MIPS (little endian) e S/390. Questo è stato anche il primo rilascio ad includere software crittografico, viste le alleggerite restrizioni imposte dagli Stati Uniti per la sua esportazione, e anche il primo ad includere KDE, dal momento che i problemi di licenza delle librerie Qt erano stati risolti. Con Bdale Garbee, recentemente nominato a capo del progetto e più di 900 sviluppatori Debian, questo rilascio conteneva circa 8500 pacchetti in formato binario e un insieme ufficiale di 7 CD.

Debian 3.1 Sarge (6 giugno 2005): ha preso il nome del sergente dell'armata dei soldatini verdi di plastica. Non sono state aggiunte nuove architetture in questa versione, anche se è stato contemporaneamente pubblicato un port non ufficiale per AMD64 distribuito attraverso il nuovo sito Alioth per hosting di progetti. Questa versione presenta un nuovo installatore: debian-installer, un software modulare dotato di funzionalità di rilevamento automatico dell'hardware e automatismi per l'installazione, interamente tradotto in più di trenta lingue. È stato anche il primo rilascio ad includere una suite per l'ufficio completa: OpenOffice.org. Branden Robinson era appena stato nominato a capo del Progetto Debian. Questo rilascio è stato realizzato da più di novecento sviluppatori Debian, conteneva circa 15.400 pacchetti binari e 14 CD nell'insieme ufficiale.

Debian 4.0 Etch (8 aprile 2007): il nome della tavoletta da disegno del film. In questo rilascio è stata aggiunta un'architettura: AMD64, ed il supporto ufficiale per m68k è stato abbandonato. Questo rilascio ha continuato ad usare il debian-installer, ma con un'interfaccia grafica per installazione, la verifica crittografica dei pacchetti scaricati, un partizionamento più flessibile (con il supporto per partizioni cifrate), una più semplice configurazione del sistema di posta, una selezione del desktop più flessibile, una localizzazione semplificata ma migliorata ed infine nuove modalità, inclusa una modalità di ripristino. Le nuove installazioni non avevano la necessità di riavviare durante il processo di installazione perché le due precedenti fasi dell'installazione erano ora integrate. Questo nuovo installatore, nella sua versione grafica, forniva il supporto per lingue complesse e scritture che usano caratteri composti, incrementando a più di cinquanta il numero delle traduzioni disponibili. Sam Hocevar è stato nominato a capo del Progetto lo stesso giorno, e gli sviluppatori che partecipavano al progetto erano più di 1030. Il rilascio era composto da circa 18.000 pacchetti binari in più di 20 CD (3 DVD) dell'insieme ufficiale. Erano disponibili anche due CD binari per l'installazione nel sistema di desktop alternativi a quello predefinito.

Debian 5.0 Lenny (febbraio 2009): ha preso il nome dal binocolo a molla dei film Toy Story. In questo rilascio è stata aggiunta un'architettura: ARM EABI (o armel) che fornisce il supporto per i processori ARM più recenti e ha reso deprecato il vecchio port ARM (arm). Il port m68k non era incluso in questo rilascio, anche se era sempre fornito nella distribuzione unstable. Questo rilascio non aveva il port FreeBSD, anche se era stato fatto molto lavoro per renderlo conforme, non soddisfaceva i requisiti per la qualificazione per questo rilascio.

Il supporto per dispositivi di piccole dimensioni in questo rilascio era aumentato con l'aggiunta del supporto per la piattaforma Orion di Marvell che era usata in molti dispositivi di archiviazione, e veniva fornito anche il supporto per svariati netbook. Erano aggiunti alcuni strumenti di compilazione che permettevano ai pacchetti Debian di essere cross-compilati e ridotti per essere adatti a sistemi ARM embedded. Inoltre erano adesso supportati anche i netbook di vari produttori e la distribuzione forniva software più adatto per computer con prestazioni relativamente basse.

Era anche il primo rilascio a fornire versioni libere della tecnologia Java di Sun, rendendo possibile fornire applicazioni Java nella sezione main.

Debian 6.0 Squeeze (febbraio 2011): ha preso il nome dagli alieni a tre occhi.

Il rilascio è stato congelato («frozen») il 6 agosto 2010 quando molti degli sviluppatori erano riuniti alla 10ª DebConf in New York.

Sebbene venissero abbandonate due architetture (alpha e hppa), venivano rese disponibili, come anteprime tecnologiche due architetture dei nuovi port FreeBSD (kfreebsd-i386 e kfreebsd-amd64), inclusi il kernel e gli strumenti in spazio utente, così come il software server comune (anche se non ancora delle funzionalità desktop avanzate). Questa era la prima volta che una distribuzione Linux veniva estesa in modo da permettere anche l'uso di un kernel non Linux.

Il nuovo rilascio ha introdotto una sequenza di avvio basata sulle dipendenze, che permette l'elaborazione in parallelo degli script init, velocizzando l'avvio del sistema.

Debian 6 è stato il primo rilascio a beneficiare del supporto a lungo termine (LTS, Long Term Support), un progetto per estendere la vita di tutti i rilasci stabili di Debian ad (almeno) 5 anni. Debian LTS non era gestito dal team Debian Security, ma da un gruppo separato di volontari e di aziende interessate a farne un successo. Debian 6 è stata supportata fino alla fine di febbraio 2016, ed era limitata alle architetture i386 e amd64.

Debian 7.0 Wheezy (maggio 2013): ha preso il nome dal pinguino di gomma con il cravattino rosso.

Il rilascio è stato congelato («frozen») il 30 giugno 2012 molto a ridosso della riunione degli sviluppatori alla 12ª DebConf in Managua, Nicaragua.

In questo rilascio era aggiunta un'architettura (armhf) e il rilascio ha introdotto il supporto multi-arch che permetteva agli utenti di installare pacchetti da più architetture sulla stessa macchina. Miglioramenti nel processo di installazione permettevano per la prima volta alle persone con problemi di vista di installare il sistema usando la sintesi vocale software.

Questo era anche il primo rilascio che supportava l'installazione e l'avvio in dispositivi con l'uso di firmware UEFI.

Debian 7 ha avuto il supporto a lungo termine (LTS) per le architetture i386, amd64, armel e armhf fino alla fine di maggio 2018.

Debian 8 Jessie (Aprile 2015): ha preso il nome dalla bambola cow-girl che è apparsa per la prima volta nel film Toy Story 2.

Questo rilascio ha introdotto per la prima volta il sistema init systemd come predefinito. Sono state introdotte due nuove architetture: arm64 e ppc64el e tre architetture sono state abbandonate: s390 (sostituita da s390x), ia64 e sparc. L'architettura Sparc è stata presente in Debian per 16 anni, ma mancava del supporto di sviluppatori per renderla mantenibile nella distribuzione.

Il rilascio ha incluso molti miglioramenti per la sicurezza, come un nuovo kernel che annullava un intero insieme di vulnerabilità di sicurezza (attacchi a collegamenti simbolici), un nuovo modo di rilevare i pacchetti per cui esiste il supporto di sicurezza, più pacchetti compilati con opzioni di compilazione per l'hardening e un nuovo meccanismo (needrestart) di rilevare sottosistemi che devono essere riavviati per poter propagare gli aggiornamenti di sicurezza dopo un aggiornamento.

Debian 8 ha avuto il supporto a lungo termine (LTS) per le architetture i386, amd64, armel e armhf fino alla fine di giugno 2020.

Debian 9 Stretch (giugno 2017): ha preso il nome dal giocattolo di gomma a forma di piovra con ventose sulle sue otto lunghe braccia che è apparso per la prima volta nel film Toy Story 3.

Il rilascio è stato congelato il 7 febbraio 2017.

Debian 9 è stata dedicata ad Ian Murdock, il fondatore del progetto, che è deceduto il 28 dicembre 2015.

Il supporto per l'architettura powerpc è stato abbandonato in questo rilascio, mentre è stata introdotta l'architettura mips64el. Questo rilascio ha introdotto un nuovo repository nell'archivio per i pacchetti di debug, i pacchetti in questo repository fornivano automaticamente i simboli di debug per i pacchetti. Firefox e Thunderbird sono rientrati in Debian, sostituendo le loro versioni rimarchiate Iceweasel e Icedove che erano presenti nell'archivio da più di 10 anni. Grazie al progetto Reproducible Builds per più del 90% dei pacchetti sorgente inclusi in Debian 9 era possibile compilare pacchetti binari identici bit per bit.

Debian 9 ha avuto il supporto a lungo termine (LTS) per le architetture i386, amd64, armel e armhf fino alla fine di giugno 2022.

Debian 10 Buster (luglio 2019): ha preso il nome dal cane di Andy, ricevuto come regalo di Natale alla fine di Toy Story.

Con questo rilascio di Debian per la prima volta era inclusa un'infrastruttura per controllo obbligatorio degli accessi abilitata in modo predefinito (AppArmor). È stato anche il primo rilascio Debian a fornire programmi basati su Rust, come Firefox, ripgrep, fd, exa, ecc. ed un numero significativo di librerie basate su Rust (più di 450). In Debian 10 GNOME usava in modo predefinito Wayland come display server invece di Xorg, fornendo un design più semplice e moderno e vantaggi per la sicurezza. Il supporto per UEFI ("Unified Extensible Firmware Interface"), introdotto in Debian 7, ha continuato ad essere molto migliorato in Debian 10, essendo incluso per le architetture amd64, i386 e arm64 e funzionando in modo predefinito sulla maggior parte delle macchine con il Secure Boot abilitato.

Debian 10 ha il supporto a lungo termine (LTS) per le architetture i386, amd64, armel e armhf fino alla fine di giugno 2024.

Debian 11 Bullseye (14 agosto 2021): ha preso il nome dal cavallo di legno giocattolo di Woody che è apparso in Toy Story 2.

Questo rilascio conteneva più di 11.294 nuovi pacchetti per un totale di 59.551 pacchetti, insieme con una significativa riduzione di più di 9.519 pacchetti che sono stati contrassegnati come "obsoleti" e rimossi. 42.821 pacchetti sono stati aggiornati e 5.434 pacchetti sono rimasti invariati.

Debian 11 permetteva la stampa e la scansione senza driver, senza la necessità di driver specifici per i diversi produttori (spesso non liberi) e forniva un kernel Linux con il supporto per il file system exFAT. Il supporto per l'architettura mips è stato abbandonato, mantenendo il supporto per le architetture mipsel (little-endian) per l'hardware a 32-bit e l'architettura mips64el per l'hardware little-endian a 64-bit.

Il team Debian Med ha partecipato alla lotta contro il COVID-19 pacchettizzando software per la ricerca sul virus a livello di sequenziamento e per lottare la pandemia con gli strumenti usati in epidemiologia; questo lavoro è continuato con un'attenzione agli strumenti per apprendimento macchina per entrambi i campi.

Debian 12 Bookworm (10 giugno 2023): ha preso il nome dal verme giocattolo verde che una torcia incorporata che è apparso in Toy Story 3.

Questo rilascio conteneva più di 11.089 nuovi pacchetti per un totale di 64.419 pacchetti, mentre più di 6.296 pacchetti sono stati rimossi come "obsoleti". Con questo rilascio sono stati aggiornati 43.254. Lo spazio totale usato su disco per bookworm è di 365.016.420 kB (365 GB), e deriva da 1.341.564.204 righe di codice.

In accordo con la Risoluzione Generale 2022 sul firmware non-free, il Debian Social Contract è stato modificato ed è stata introdotta una nuova area dell'archivio chiamata non-free-firmware, rendendo possibile la separazione del firmware non libero dagli altri pacchetti non liberi. La maggior parte dei pacchetti di firmware non libero sono stati spostati da non-free a non-free-firmware. Questa separazione rende possibile creare una varietà di immagini di installazioni ufficiali. E rende molto più facile l'installazione di Debian sull'hardware comune usando l'installatore Debian.

Per bookworm è supportato un totale di nove architetture.

Il team Debian Cloud pubblica bookworm per tre popolari servizi di calcolo in cloud.

Tra i rilasci, nel Bug#978636 (Feb 2021), il Comitato Tecnico ha stabilito che Debian bookworm avrebbe supportato solo la struttura merged-usr[1] del file system root, abbandonando il supporto per la disposizione non-merged-usr. Per i sistemi installati come buster o bullseye non erano previste modifiche al file system; tuttavia i sistemi con in uso la vecchia struttura sarebbero stati convertiti durante l'aggiornamento.

Grazie al lavoro congiunto del team Debian Security e di quello Debian Long Term Support, bookworm avrà il supporto su quattro architetture fino a giugno 2028 (5 anni dopo il rilascio).

Debian 13 Trixie (la distribuzione testing ad agosto 2024): Trixie è un triceratopo giocattolo blu che è apparso in Toy Story 3.

[1] usr-merge (o merged-usr o `/usr`-move) è una organizzazione del file system in cui le tradizionali directory unix `/bin`, `/sbin`, `/lib` e `/lib64` sono sostituite da collegamenti simbolici alle loro controparti in `/usr`. Perciò, ad esempio `/bin` è sostituita da un collegamento simbolico a `/usr/bin` . Nel 2012 usr-merge è stato implementato da Fedora Linux e anche da Ubuntu Linux. Vedere anche The Case For The Usr Merge e le Note di Rilascio di Bookworm.

Capitolo 2. Guida del progetto |  | Capitolo 4. La storia in dettaglio